 
 
 
 
 /***********************************************************************************************************
 *                                                -= Audio =-
 ***********************************************************************************************************/
 


 function AudioPlayer() {
	this.MAX_TRACKS = 1;
	this.trackNum = 1;
	this.player = null;
	this.isMuted = false;
	this.isTempMuted = false;
	this.isPlaying = true;
 }
 
 AudioPlayer.prototype.isHTML5Audio = function() {
	return !!document.createElement('audio').volume;
 }
  
 AudioPlayer.prototype.isMobile = function() {
	return navigator.userAgent.match(/(iPod|iPhone|iPad|Android)/);
 }
 
 AudioPlayer.prototype.init = function(autoplay) {
	if (this.isHTML5Audio()) {
		this.player = new AudioHTML5();
	} else {
		this.player = new AudioFlash();
	}
	this.player.init();
	
	if (!autoplay) {
		this.tempMute();
		//this.pause();
	}
 }
 
 
 AudioPlayer.prototype.toggle = function() {
	//console.log('toggle '+this.isMuted);
	if (this.isMuted) {
		this.unmute();
		this.isMuted = false;
	} else {
		this.mute();
		this.isMuted = true;
	}
}

AudioPlayer.prototype.play = function(){
	if (this.isMobile()) return;
	
	if (!this.isPlaying) {
		this.player.play();
	}
	this.isPlaying = true;
}

AudioPlayer.prototype.pause = function(){
    if (this.isPlaying) {
        this.player.pause();
    }
    this.isPlaying = false;
}

AudioPlayer.prototype.setVolume = function(vol){
    this.player.setVolume(vol);
}
 
AudioPlayer.prototype.mute = function(){
	this.isMuted = true;
    this.player.mute();
}

AudioPlayer.prototype.tempMute = function(){
	this.isTempMuted = true;
	//this.isMuted = true;
    this.player.mute();
}

AudioPlayer.prototype.tempUnmute = function(){
	this.isTempMuted = false;
	if (!this.isMuted) {
		this.player.unmute();
	}	
}

AudioPlayer.prototype.unmute = function(){
	//console.log(this.isMuted);
	if (this.isMuted) {
		this.isMuted = false;
		if (!this.isMobile())
			this.player.unmute();
	}		
}


AudioPlayer.prototype.changeTrack = function(name){
	if (!this.isMobile())
		this.player.changeTrack(name);
}

function AudioHTML5(autoplay) {
	this.audioId = 'htmlAudio';
	this.volume = 1;
 }
 
AudioHTML5.prototype.init = function() {
	//this.tracknum = 1;
	this.path = "music/";
	var track = 'track_1';
	var str = '	<audio preload="metadata" autoplay="true" id="'+this.audioId+'">'+
	'		<source id="audio_mp3" src="music/'+track+'.mp3" type="audio/mp3"/>'+
	'		<source id="audio_ogg" src="music/'+track+'.ogg" type="audio/ogg"/>'+
	'	</audio>';
	
	document.write(str);	
	this.setOnFinish();
 }
 
 AudioHTML5.prototype.setOnFinish = function() {
	document.getElementById(this.audioId).addEventListener('ended', this.onFinish, false);	
 }
 
 AudioHTML5.prototype.onFinish = function() {
	this.currentTime = 0;
	this.play();
 }
 
 AudioHTML5.prototype.changeTrack = function(name) {
	var source = $("#audio_mp3");
	source.attr("src", this.path+name+'.mp3').appendTo(source.parent());
	source = $("#audio_ogg");
	source.attr("src", this.path+name+'.ogg').appendTo(source.parent());
	
	//$('#audio_mp3').attr('src', this.path+name+'.mp3');
	//$('#audio_ogg').attr('src', this.path+name+'.ogg');
	
 	var player = this.getEl();
	player.load();
	player.play();
 }
 
 
 
 AudioHTML5.prototype.load = function() {
	this.getEl().load();
 }
 
 AudioHTML5.prototype.play = function() {
 	this.getEl().play();
 }
 
 AudioHTML5.prototype.pause = function() {
	this.getEl().pause();
 }
 
 AudioHTML5.prototype.mute = function() {
	this.getEl().volume = 0;
 }
 
 AudioHTML5.prototype.unmute = function() {
	this.getEl().volume = this.volume;
 }
 
 AudioHTML5.prototype.setVolume = function(vol) {
	this.volume = this.getEl().volume = vol;
 }
 
 AudioHTML5.prototype.startSFX = function(name) {
	// todo
	this.getEl().startSFX(name);
 }
 
 AudioHTML5.prototype.getEl = function() {
	 //return parent.window.document.getElementById(this.audioId);
	 return document.getElementById(this.audioId);
 }
 
 function AudioFlash() {
	this.audioId = 'flashAudio';	
	this.volume = 1;
 }
 
 AudioFlash.prototype.init = function() {
	var width = 41;
	var height = 39;
	var track = 'bgmusic';
	swfobject.embedSWF('music/mp3Player.swf', 'music-swf', width, height, '8.0.0', false, {mp3path:"music/track_1.mp3", reset: true}, {quality: "low", wmode:"transparent", menu: "false", allowScriptAccess: "always"}, {id: 'flashAudio', name: 'flashAudio', styleClass:'flash-swf'})	
 }
 
 AudioFlash.prototype.play = function() {
	if (this.getEl() != null)
		this.getEl().play();
 }

 AudioFlash.prototype.pause = function() {
	if (this.getEl() != null)
		this.getEl().mute();
 } 
 
 AudioFlash.prototype.mute = function() {
	if (this.getEl() != null)
		this.getEl().mute();
 }
 
 AudioFlash.prototype.unmute = function() {
	if (this.getEl() != null)
		this.getEl().unmute();
 }
 
 AudioFlash.prototype.changeTrack = function(name) {
	if (this.getEl() != null)
		this.getEl().changeTrack(name);
}
 
 AudioFlash.prototype.startSFX = function(name) {
	if (this.getEl() != null)
		this.getEl().startSFX(name);
 }
 
 AudioFlash.prototype.setVolume = function(vol) {
	this.volume = vol;
	if (this.getEl() != null) 
		this.getEl().setVolume(vol);
 }
 
 AudioFlash.prototype.onFinish = function() {
	console.log("onFinish FlashAudio");
 }
 
 AudioFlash.prototype.getEl = function() {
	 //return parent.window.document.getElementById(this.audioId);
	 return window.document.getElementById(this.audioId);
 }
 

 