/*!
* jQuery UI Widget 1.10.0
* http://jqueryui.com
*
* Copyright 2013 jQuery Foundation and other contributors
* Released under the MIT license.
* http://jquery.org/license
*
* http://api.jqueryui.com/jQuery.widget/
*/
(function( $, undefined ) {

var uuid = 0,
slice = Array.prototype.slice,
_cleanData = $.cleanData;
$.cleanData = function( elems ) {
for ( var i = 0, elem; (elem = elems[i]) != null; i++ ) {
try {
$( elem ).triggerHandler( "remove" );
// http://bugs.jquery.com/ticket/8235
} catch( e ) {}
}
_cleanData( elems );
};

$.widget = function( name, base, prototype ) {
var fullName, existingConstructor, constructor, basePrototype,
// proxiedPrototype allows the provided prototype to remain unmodified
// so that it can be used as a mixin for multiple widgets (#8876)
proxiedPrototype = {},
namespace = name.split( "." )[ 0 ];

name = name.split( "." )[ 1 ];
fullName = namespace + "-" + name;

if ( !prototype ) {
prototype = base;
base = $.Widget;
}

// create selector for plugin
$.expr[ ":" ][ fullName.toLowerCase() ] = function( elem ) {
return !!$.data( elem, fullName );
};

$[ namespace ] = $[ namespace ] || {};
existingConstructor = $[ namespace ][ name ];
constructor = $[ namespace ][ name ] = function( options, element ) {
// allow instantiation without "new" keyword
if ( !this._createWidget ) {
return new constructor( options, element );
}

// allow instantiation without initializing for simple inheritance
// must use "new" keyword (the code above always passes args)
if ( arguments.length ) {
this._createWidget( options, element );
}
};
// extend with the existing constructor to carry over any static properties
$.extend( constructor, existingConstructor, {
version: prototype.version,
// copy the object used to create the prototype in case we need to
// redefine the widget later
_proto: $.extend( {}, prototype ),
// track widgets that inherit from this widget in case this widget is
// redefined after a widget inherits from it
_childConstructors: []
});

basePrototype = new base();
// we need to make the options hash a property directly on the new instance
// otherwise we'll modify the options hash on the prototype that we're
// inheriting from
basePrototype.options = $.widget.extend( {}, basePrototype.options );
$.each( prototype, function( prop, value ) {
if ( !$.isFunction( value ) ) {
proxiedPrototype[ prop ] = value;
return;
}
proxiedPrototype[ prop ] = (function() {
var _super = function() {
return base.prototype[ prop ].apply( this, arguments );
},
_superApply = function( args ) {
return base.prototype[ prop ].apply( this, args );
};
return function() {
var __super = this._super,
__superApply = this._superApply,
returnValue;

this._super = _super;
this._superApply = _superApply;

returnValue = value.apply( this, arguments );

this._super = __super;
this._superApply = __superApply;

return returnValue;
};
})();
});
constructor.prototype = $.widget.extend( basePrototype, {
// TODO: remove support for widgetEventPrefix
// always use the name + a colon as the prefix, e.g., draggable:start
// don't prefix for widgets that aren't DOM-based
widgetEventPrefix: existingConstructor ? basePrototype.widgetEventPrefix : name
}, proxiedPrototype, {
constructor: constructor,
namespace: namespace,
widgetName: name,
widgetFullName: fullName
});

// If this widget is being redefined then we need to find all widgets that
// are inheriting from it and redefine all of them so that they inherit from
// the new version of this widget. We're essentially trying to replace one
// level in the prototype chain.
if ( existingConstructor ) {
$.each( existingConstructor._childConstructors, function( i, child ) {
var childPrototype = child.prototype;

// redefine the child widget using the same prototype that was
// originally used, but inherit from the new version of the base
$.widget( childPrototype.namespace + "." + childPrototype.widgetName, constructor, child._proto );
});
// remove the list of existing child constructors from the old constructor
// so the old child constructors can be garbage collected
delete existingConstructor._childConstructors;
} else {
base._childConstructors.push( constructor );
}

$.widget.bridge( name, constructor );
};

$.widget.extend = function( target ) {
var input = slice.call( arguments, 1 ),
inputIndex = 0,
inputLength = input.length,
key,
value;
for ( ; inputIndex < inputLength; inputIndex++ ) {
for ( key in input[ inputIndex ] ) {
value = input[ inputIndex ][ key ];
if ( input[ inputIndex ].hasOwnProperty( key ) && value !== undefined ) {
// Clone objects
if ( $.isPlainObject( value ) ) {
target[ key ] = $.isPlainObject( target[ key ] ) ?
$.widget.extend( {}, target[ key ], value ) :
// Don't extend strings, arrays, etc. with objects
$.widget.extend( {}, value );
// Copy everything else by reference
} else {
target[ key ] = value;
}
}
}
}
return target;
};

$.widget.bridge = function( name, object ) {
var fullName = object.prototype.widgetFullName || name;
$.fn[ name ] = function( options ) {
var isMethodCall = typeof options === "string",
args = slice.call( arguments, 1 ),
returnValue = this;

// allow multiple hashes to be passed on init
options = !isMethodCall && args.length ?
$.widget.extend.apply( null, [ options ].concat(args) ) :
options;

if ( isMethodCall ) {
this.each(function() {
var methodValue,
instance = $.data( this, fullName );
if ( !instance ) {
return $.error( "cannot call methods on " + name + " prior to initialization; " +
"attempted to call method '" + options + "'" );
}
if ( !$.isFunction( instance[options] ) || options.charAt( 0 ) === "_" ) {
return $.error( "no such method '" + options + "' for " + name + " widget instance" );
}
methodValue = instance[ options ].apply( instance, args );
if ( methodValue !== instance && methodValue !== undefined ) {
returnValue = methodValue && methodValue.jquery ?
returnValue.pushStack( methodValue.get() ) :
methodValue;
return false;
}
});
} else {
this.each(function() {
var instance = $.data( this, fullName );
if ( instance ) {
instance.option( options || {} )._init();
} else {
$.data( this, fullName, new object( options, this ) );
}
});
}

return returnValue;
};
};

$.Widget = function( /* options, element */ ) {};
$.Widget._childConstructors = [];

$.Widget.prototype = {
widgetName: "widget",
widgetEventPrefix: "",
defaultElement: "<div>",
options: {
disabled: false,

// callbacks
create: null
},
_createWidget: function( options, element ) {
element = $( element || this.defaultElement || this )[ 0 ];
this.element = $( element );
this.uuid = uuid++;
this.eventNamespace = "." + this.widgetName + this.uuid;
this.options = $.widget.extend( {},
this.options,
this._getCreateOptions(),
options );

this.bindings = $();
this.hoverable = $();
this.focusable = $();

if ( element !== this ) {
$.data( element, this.widgetFullName, this );
this._on( true, this.element, {
remove: function( event ) {
if ( event.target === element ) {
this.destroy();
}
}
});
this.document = $( element.style ?
// element within the document
element.ownerDocument :
// element is window or document
element.document || element );
this.window = $( this.document[0].defaultView || this.document[0].parentWindow );
}

this._create();
this._trigger( "create", null, this._getCreateEventData() );
this._init();
},
_getCreateOptions: $.noop,
_getCreateEventData: $.noop,
_create: $.noop,
_init: $.noop,

destroy: function() {
this._destroy();
// we can probably remove the unbind calls in 2.0
// all event bindings should go through this._on()
this.element
.unbind( this.eventNamespace )
// 1.9 BC for #7810
// TODO remove dual storage
.removeData( this.widgetName )
.removeData( this.widgetFullName )
// support: jquery <1.6.3
// http://bugs.jquery.com/ticket/9413
.removeData( $.camelCase( this.widgetFullName ) );
this.widget()
.unbind( this.eventNamespace )
.removeAttr( "aria-disabled" )
.removeClass(
this.widgetFullName + "-disabled " +
"ui-state-disabled" );

// clean up events and states
this.bindings.unbind( this.eventNamespace );
this.hoverable.removeClass( "ui-state-hover" );
this.focusable.removeClass( "ui-state-focus" );
},
_destroy: $.noop,

widget: function() {
return this.element;
},

option: function( key, value ) {
var options = key,
parts,
curOption,
i;

if ( arguments.length === 0 ) {
// don't return a reference to the internal hash
return $.widget.extend( {}, this.options );
}

if ( typeof key === "string" ) {
// handle nested keys, e.g., "foo.bar" => { foo: { bar: ___ } }
options = {};
parts = key.split( "." );
key = parts.shift();
if ( parts.length ) {
curOption = options[ key ] = $.widget.extend( {}, this.options[ key ] );
for ( i = 0; i < parts.length - 1; i++ ) {
curOption[ parts[ i ] ] = curOption[ parts[ i ] ] || {};
curOption = curOption[ parts[ i ] ];
}
key = parts.pop();
if ( value === undefined ) {
return curOption[ key ] === undefined ? null : curOption[ key ];
}
curOption[ key ] = value;
} else {
if ( value === undefined ) {
return this.options[ key ] === undefined ? null : this.options[ key ];
}
options[ key ] = value;
}
}

this._setOptions( options );

return this;
},
_setOptions: function( options ) {
var key;

for ( key in options ) {
this._setOption( key, options[ key ] );
}

return this;
},
_setOption: function( key, value ) {
this.options[ key ] = value;

if ( key === "disabled" ) {
this.widget()
.toggleClass( this.widgetFullName + "-disabled ui-state-disabled", !!value )
.attr( "aria-disabled", value );
this.hoverable.removeClass( "ui-state-hover" );
this.focusable.removeClass( "ui-state-focus" );
}

return this;
},

enable: function() {
return this._setOption( "disabled", false );
},
disable: function() {
return this._setOption( "disabled", true );
},

_on: function( suppressDisabledCheck, element, handlers ) {
var delegateElement,
instance = this;

// no suppressDisabledCheck flag, shuffle arguments
if ( typeof suppressDisabledCheck !== "boolean" ) {
handlers = element;
element = suppressDisabledCheck;
suppressDisabledCheck = false;
}

// no element argument, shuffle and use this.element
if ( !handlers ) {
handlers = element;
element = this.element;
delegateElement = this.widget();
} else {
// accept selectors, DOM elements
element = delegateElement = $( element );
this.bindings = this.bindings.add( element );
}

$.each( handlers, function( event, handler ) {
function handlerProxy() {
// allow widgets to customize the disabled handling
// - disabled as an array instead of boolean
// - disabled class as method for disabling individual parts
if ( !suppressDisabledCheck &&
( instance.options.disabled === true ||
$( this ).hasClass( "ui-state-disabled" ) ) ) {
return;
}
return ( typeof handler === "string" ? instance[ handler ] : handler )
.apply( instance, arguments );
}

// copy the guid so direct unbinding works
if ( typeof handler !== "string" ) {
handlerProxy.guid = handler.guid =
handler.guid || handlerProxy.guid || $.guid++;
}

var match = event.match( /^(\w+)\s*(.*)$/ ),
eventName = match[1] + instance.eventNamespace,
selector = match[2];
if ( selector ) {
delegateElement.delegate( selector, eventName, handlerProxy );
} else {
element.bind( eventName, handlerProxy );
}
});
},

_off: function( element, eventName ) {
eventName = (eventName || "").split( " " ).join( this.eventNamespace + " " ) + this.eventNamespace;
element.unbind( eventName ).undelegate( eventName );
},

_delay: function( handler, delay ) {
function handlerProxy() {
return ( typeof handler === "string" ? instance[ handler ] : handler )
.apply( instance, arguments );
}
var instance = this;
return setTimeout( handlerProxy, delay || 0 );
},

_hoverable: function( element ) {
this.hoverable = this.hoverable.add( element );
this._on( element, {
mouseenter: function( event ) {
$( event.currentTarget ).addClass( "ui-state-hover" );
},
mouseleave: function( event ) {
$( event.currentTarget ).removeClass( "ui-state-hover" );
}
});
},

_focusable: function( element ) {
this.focusable = this.focusable.add( element );
this._on( element, {
focusin: function( event ) {
$( event.currentTarget ).addClass( "ui-state-focus" );
},
focusout: function( event ) {
$( event.currentTarget ).removeClass( "ui-state-focus" );
}
});
},

_trigger: function( type, event, data ) {
var prop, orig,
callback = this.options[ type ];

data = data || {};
event = $.Event( event );
event.type = ( type === this.widgetEventPrefix ?
type :
this.widgetEventPrefix + type ).toLowerCase();
// the original event may come from any element
// so we need to reset the target on the new event
event.target = this.element[ 0 ];

// copy original event properties over to the new event
orig = event.originalEvent;
if ( orig ) {
for ( prop in orig ) {
if ( !( prop in event ) ) {
event[ prop ] = orig[ prop ];
}
}
}

this.element.trigger( event, data );
return !( $.isFunction( callback ) &&
callback.apply( this.element[0], [ event ].concat( data ) ) === false ||
event.isDefaultPrevented() );
}
};

$.each( { show: "fadeIn", hide: "fadeOut" }, function( method, defaultEffect ) {
$.Widget.prototype[ "_" + method ] = function( element, options, callback ) {
if ( typeof options === "string" ) {
options = { effect: options };
}
var hasOptions,
effectName = !options ?
method :
options === true || typeof options === "number" ?
defaultEffect :
options.effect || defaultEffect;
options = options || {};
if ( typeof options === "number" ) {
options = { duration: options };
}
hasOptions = !$.isEmptyObject( options );
options.complete = callback;
if ( options.delay ) {
element.delay( options.delay );
}
if ( hasOptions && $.effects && $.effects.effect[ effectName ] ) {
element[ method ]( options );
} else if ( effectName !== method && element[ effectName ] ) {
element[ effectName ]( options.duration, options.easing, callback );
} else {
element.queue(function( next ) {
$( this )[ method ]();
if ( callback ) {
callback.call( element[ 0 ] );
}
next();
});
}
};
});

})( jQuery );


/*global jQuery */
/*jshint bitwise: true, camelcase: true, curly: true, eqeqeq: true, forin: true,
immed: true, indent: 4, latedef: true, newcap: true, nonew: true, quotmark: single,
undef: true, unused: true, strict: true, trailing: true, browser: true */

/*
* jquery.rs.carousel.js v0.11.2
* https://github.com/richardscarrott/jquery-ui-carousel
*
* Copyright (c) 2013 Richard Scarrott
* http://www.richardscarrott.co.uk
*
* Dual licensed under the MIT and GPL licenses:
* http://www.opensource.org/licenses/mit-license.php
* http://www.gnu.org/licenses/gpl.html
*
* Depends:
* jquery.js v1.8+
* jquery.ui.widget.js v1.8+
*/

(function ($, undefined) {

    'use strict';

    var _super = $.Widget.prototype;

    $.widget('rs.carousel', {

        version: '0.11.2',

        options: {
            // selectors
            mask: '> div',
            runner: '> ul',
            items: '> li',
			
            // options
            itemsPerTransition: 'auto',
            orientation: 'horizontal',
            loop: false,
            whitespace: false,
            nextPrevActions: true,
            insertPrevAction: function () {
                return $('<a href="#" class="rs-carousel-action rs-carousel-action-prev"></a>').appendTo(this);
            },
            insertNextAction: function () {
                return $('<a href="#" class="rs-carousel-action rs-carousel-action-next"></a>').appendTo(this);
            },
            pagination: false,
            insertPagination: function (pagination) {
                return $(pagination).insertAfter($(this).find('.rs-carousel-mask'));
            },
            speed: 'normal',
            easing: 'swing',
            fx: 'slide',
            translate3d: false,

            // callbacks
            create: null,
            before: null,
            after: null
        },

        _create: function () {

            // widget factory 1.8.* backwards compat
            this.widgetFullName = this.widgetFullName || this.widgetBaseClass;
            this.eventNamespace = this.eventNamespace || '.' + this.widgetName;

            this.index = 0;
            this._elements();
            this._setIsHorizontal();
            this._addMask();
            this._addNextPrevActions();
            this.refresh(false);

            return;
        },

        // caches DOM elements
        _elements: function () {

            var elems = this.elements = {},
                fullName = this.widgetFullName;

            this.element.addClass(fullName);

            elems.mask = this.element
                .find(this.options.mask)
                    .addClass(fullName + '-mask');

            elems.runner = (elems.mask.length ? elems.mask : this.element)
                    .find(this.options.runner)
                            .addClass(fullName + '-runner');

            elems.items = elems.runner
                .find(this.options.items)
                    .addClass(fullName + '-item');

            return;
        },

        _setIsHorizontal: function () {

            var elems = this.elements,
                fullName = this.widgetFullName;

            this.element
                .removeClass(fullName + '-horizontal')
                .removeClass(fullName + '-vertical');

            if (this.options.orientation === 'horizontal') {
                this.isHorizontal = true;
                this.element.addClass(fullName + '-horizontal');
                elems.runner.css('top', '');
            }
            else {
                this.isHorizontal = false;
                this.element.addClass(fullName + '-vertical');
                elems.runner.css('left', '');
            }

            return;
        },

        // adds masking div (aka clipper)
        _addMask: function () {

            var elems = this.elements;

            // already exists in markup
            if (elems.mask.length) {
                return;
            }

            elems.mask = elems.runner
                .wrap('<div class="' + this.widgetFullName + '-mask" />')
                .parent();

            // indicates whether mask was dynamically added or already existed in mark-up
            this.maskAdded = true;

            return;
        },

        // adds next and prev links
        _addNextPrevActions: function () {

            if (!this.options.nextPrevActions) {
                return;
            }

            var self = this,
                elems = this.elements,
                opts = this.options,
                eventNamespace = this.eventNamespace;

            this._removeNextPrevActions();

            elems.prevAction = opts.insertPrevAction.apply(this.element[0])
                .bind('click' + eventNamespace, function (e) {
                    e.preventDefault();
                    self.prev();
                });

            elems.nextAction = opts.insertNextAction.apply(this.element[0])
                .bind('click' + eventNamespace, function (e) {
                    e.preventDefault();
                    self.next();
                });

            return;
        },

        _removeNextPrevActions: function () {

            var elems = this.elements;

            if (elems.nextAction) {
                elems.nextAction.remove();
                elems.nextAction = undefined;
            }

            if (elems.prevAction) {
                elems.prevAction.remove();
                elems.prevAction = undefined;
            }

            return;
        },

        // refresh carousel
        refresh: function (recache) {

            // undefined should pass condition
            if (recache !== false) {
                this._recacheItems();
            }

            this._setPages();
            this._addPagination();
            this._setRunnerWidth();
            this.index = this._makeValid(this.index);
            this.goToPage(this.index, false, undefined, true);
            this._checkDisabled();

            return;
        },

        // re-cache items in case new items have been added,
        // moved to own method so continuous can easily override
        // to avoid clones
        _recacheItems: function () {

            this.elements.items = this.elements.runner
                .find(this.options.items)
                    .addClass(this.widgetFullName + '-item');

            return;
        },

        // sets pages array - [jQuery(li, li, li), jQuery(li, li, li, li), jQuery(li, li, li), jQuery(li, li)]
        _setPages: function () {

            var self = this,
                itemIndex = 0,
                lastItemIndex = isNaN(this.options.itemsPerTransition) ? undefined : this._getLastItemIndex(),
                start;

            this.pages = [];

            while (itemIndex < this.getNoOfItems()) {

                // if itemsPerTransition isn't a number we need to get the visible
                // items at each item index
                if (isNaN(this.options.itemsPerTransition)) {
                    this.pages.push(self._getVisibleItems(itemIndex));
                    itemIndex += this.pages[this.pages.length - 1].length;
                }
                // otherwise simply slice up the items based on itemsPerTransition
                else {
                    // making sure we don't go past the lastItemIndex
                    if (itemIndex >= lastItemIndex) {
                        this.pages.push(this.elements.items.slice(itemIndex));
                        break;
                    }
                    start = itemIndex;
                    // #37 - allow `itemsPerTransition` to be passed in as string
                    itemIndex += parseInt(this.options.itemsPerTransition, 10);
                    this.pages.push(this.elements.items.slice(start, itemIndex));
                }
            }

            return;
        },

        // returns last logical item index
        _getLastItemIndex: function () {

            if (this.options.whitespace) {
                return;
            }

            return this.elements.items.index(this._getVisibleItems(0, true).last());
        },

        // returns a jquery object containing the visible items where the `itemIndex`
        // is considered to be the first visible item. Passing in reverse as true allows
        // us to, for example, return the visible items from the last item backwards.
        _getVisibleItems: function (itemIndex, reverse) {

            var self = this,
                page = [],
                items = !reverse ? this.elements.items.slice(itemIndex) : [].reverse.apply($(this.elements.items)).slice(itemIndex),
                maskDim = this._getMaskDim(),
                dim = 0;

            items
                .each(function () {
                    dim += self.isHorizontal ? $(this).outerWidth(true) : $(this).outerHeight(true);
                    if (dim > maskDim) {
                        // if no items have been pushed to page then it means the
                        // first item is larger than the mask so we still need to push before
                        // breaking.
                        if (page.length === 0) {
                            page.push(this);
                        }
                        return false;
                    }
                    page.push(this);
                });

            return $(page);
        },

        _getMaskDim: function () {

            return this.elements.mask[this.isHorizontal ? 'width' : 'height']();

        },

        getNoOfItems: function () {

            return this.elements.items.length;

        },

        // adds pagination links and binds associated events
        _addPagination: function () {

            if (!this.options.pagination) {
                return;
            }

            var self = this,
                fullName = this.widgetFullName,
                pagination = $('<ol class="' + fullName + '-pagination" />'),
                links = [],
                noOfPages = this.getNoOfPages(),
                i;

            this._removePagination();

            for (i = 0; i < noOfPages; i++) {
                links[i] = '<li class="' + fullName + '-pagination-link"><a href="#page-' + i + '">' + (i + 1) + '</a></li>';
            }

            pagination
                .append(links.join(''))
                .delegate('a', 'click' + this.eventNamespace, function (e) {
                    e.preventDefault();
                    self.goToPage(parseInt(this.hash.split('-')[1], 10));
                });

            this.elements.pagination = this.options.insertPagination.call(this.element[0], pagination);

            return;
        },

        _removePagination: function () {

            if (this.elements.pagination) {
                this.elements.pagination.remove();
                this.elements.pagination = undefined;
            }

            return;
        },

        // returns noOfPages
        getNoOfPages: function () {

            return this.pages.length;

        },

        // if no of items is less than items on first page then the
        // carousel should be disabled.
        _checkDisabled: function () {

            if (this.getNoOfPages() <= 1) {
                this.disable();
                this._disabled = true;
            }
            // only enable if carousel was disabled internally.
            else if (this._disabled) {
                this.enable();
                this._disabled = false;
            }

            return;
        },

        _setRunnerWidth: function () {

            var elems = this.elements,
                width = 0;

            // reset width in case orientation has been changed
            elems.runner.width('');

            if (!this.isHorizontal) {
                return;
            }

            elems.runner
                .width(function () {
                    elems.items
                        .each(function () {
                            width += $(this).outerWidth(true);
                        });

                    return width;
                });

            return;
        },

        next: function (animate) {

            var index = this.index + 1;

            if (this.options.loop && index >= this.getNoOfPages()) {
                index = 0;
            }

            this.goToPage(index, animate, 'carousel:next');

            return;
        },

        prev: function (animate) {

            var index = this.index - 1;

            if (this.options.loop && index < 0) {
                index = this.getNoOfPages() - 1;
            }

            this.goToPage(index, animate, 'carousel:prev');

            return;
        },

        goToPage: function (index, animate, /* INTERNAL */ eventName, /* INTERNAL */ silent) {

            // undefined should pass
            animate = animate === false ? false : true;

            if (!this.options.disabled && this._isValid(index)) {
                this.prevIndex = this.index;
                this.index = index;
                // calling `this._slide` using `options.fx` to easily override within extensions
                this['_' + this.options.fx]($.Event(eventName ? eventName : 'carousel:gotopage', {
                    animate: animate,
                    speed: animate ? this.options.speed : 0
                }), silent);
            }

            // make sure updateUi is called even when disabled
            this._updateUi();

            return;
        },

        // `index` can be $obj, element or 0 based index
        goToItem: function (index, animate) {

            var page,
                pageLength,
                item,
                itemLength;

            // if a number get the element
            if (!isNaN(index)) {
                index = this.elements.items.eq(index);
            }

            if (index.jquery) {
                // unwrap from jquery object
                index = index[0];
            }

            // find item in pages array
            pages:
            for (page = 0, pageLength = this.getNoOfPages(); page < pageLength; page++) {
                for (item = 0, itemLength = this.getPage(page).length; item < itemLength; item++) {
                    if (this.getPage(page)[item] === index) {
                        break pages;
                    }
                }
            }

            this.goToPage(page, animate);

            // return item as jquery object
            return $(index);
        },

        // returns true if index is valid, false if not
        _isValid: function (index) {

            if (index < this.getNoOfPages() && index >= 0) {
                return true;
            }

            return false;
        },

        // returns valid page index
        _makeValid: function (index) {

            if (index < 0) {
                index = 0;
            }
            else if (index >= this.getNoOfPages()) {
                index = this.getNoOfPages() - 1;
            }

            return index;
        },

        // if silent is true callbacks won't be fired
        _slide: function (e, silent) {

            var self = this,
                animateProps = {},
                lastPos = this._getAbsoluteLastPos(),
                page = this.getPage(),
                pos = page.first().position()[this.isHorizontal ? 'left' : 'top'],
                eventNamespace = this.eventNamespace,
                fullName = this.widgetFullName,
                transitionEndEvent;

            // if before returns false return and revert index back to prevIndex
            if (!silent && !this._trigger('before', e, this._getEventData())) {
                this.index = this.prevIndex;
                return;
            }

            // check pos doesn't go past last posible pos
            if (pos > lastPos) {
                pos = lastPos;
            }

            if (this.options.translate3d) {

                transitionEndEvent = [
                    'transitionend' + eventNamespace,
                    'webkitTransitionEnd' + eventNamespace,
                    'oTransitionEnd' + eventNamespace
                ];

                if (e.animate) {
                    this.element.addClass(fullName + '-transition');
                }

                this.elements.runner
                    .unbind(transitionEndEvent.join(' '))
                    .on(transitionEndEvent.join(' '), function (e) {
                        self.element.removeClass(fullName + '-transition');
                        if (!silent) {
                            self._trigger('after', e, self._getEventData());
                        }
                    })
                    .css('transform', 'translate3d(' + (this.isHorizontal ? -pos + 'px, 0, 0' : '0, ' + -pos + 'px, 0') + ')');

                // if we're not animating the after callback should still be called
                if (!e.animate) {
                    self.element.removeClass(fullName + '-transition');
                    if (!silent) {
                        self._trigger('after', e, self._getEventData());
                    }
                }

            }
            else {

                animateProps[this.isHorizontal ? 'left' : 'top'] = -pos;
                this.elements.runner
                    .stop()
                    .animate(animateProps, e.speed, this.options.easing, function () {
                        if (!silent) {
                            self._trigger('after', e, self._getEventData());
                        }
                    });

            }

            return;
        },

        // gets lastPos to ensure runner doesn't move beyond mask
        _getAbsoluteLastPos: function () {

            if (this.options.whitespace) {
                return;
            }

            var lastPos,
                lastItem = this.elements.items.eq(this.getNoOfItems() - 1),
                lastItemPos = lastItem.position()[this.isHorizontal ? 'left' : 'top'],
                lastItemDim = lastItem[this.isHorizontal ? 'outerWidth' : 'outerHeight'](true);

            lastPos = lastItemPos + lastItemDim - this._getMaskDim();

            // if lastPos is less than 0 it means there aren't enough items to fill the entire mask
            return lastPos < 0 ? undefined : lastPos;
        },

        // returns jQuery object of items on page
        getPage: function (index) {

            return this.pages[(typeof index !== 'undefined' ? index : this.index)] || $([]);

        },

        // returns pages array
        getPages: function () {

            return this.pages;

        },

        _getEventData: function () {

            return {
                page: this.getPage(),
                prevPage: this.getPage(this.prevIndex),
                elements: this.elements
            };

        },

        _getCreateEventData: function () {

            return this._getEventData();

        },

        // updates pagination, next and prev link state classes
        _updateUi: function () {

            if (this.options.pagination) {
                this._updatePagination();
            }

            if (this.options.nextPrevActions) {
                this._updateNextPrevActions();
            }

            return;
        },

        _updatePagination: function () {

            var fullName = this.widgetFullName,
                activeClass = fullName + '-pagination-link-active',
                disabledClass = fullName + '-pagination-disabled',
                pagination = this.elements.pagination
                    .removeClass(disabledClass);

            if (this.options.disabled) {
                pagination.addClass(disabledClass);
            }

            pagination
                .children('.' + fullName + '-pagination-link')
                    .removeClass(activeClass)
                    .eq(this.index)
                        .addClass(activeClass);

            return;
        },

        _updateNextPrevActions: function () {

            var elems = this.elements,
                actions = elems.nextAction.add(elems.prevAction),
                index = this.index,
                fullName = this.widgetFullName,
                activeClass = fullName + '-action-active',
                disabledClass = fullName + '-action-disabled';

            actions
                .addClass(activeClass)
                .removeClass(disabledClass);

            if (this.options.disabled) {
                actions.addClass(disabledClass);
            }

            if (!this.options.loop) {

                if (index === this.getNoOfPages() - 1) {
                    elems.nextAction
                        .removeClass(activeClass);
                }

                if (index === 0) {
                    elems.prevAction
                        .removeClass(activeClass);
                }

            }

            return;
        },

        _setOption: function (option, value) {

            _super._setOption.apply(this, arguments);

            switch (option) {

            case 'orientation':

                this._setIsHorizontal();
                this.refresh();

                break;

            case 'pagination':

                if (value) {
                    this._addPagination();
                    this._updateUi();
                }
                else {
                    this._removePagination();
                }

                break;

            case 'nextPrevActions':

                if (value) {
                    this._addNextPrevActions();
                    this._updateUi();
                }
                else {
                    this._removeNextPrevActions();
                }

                break;

            case 'loop':
            case 'disabled':

                this._updateUi();

                break;

            case 'itemsPerTransition':
            case 'whitespace':

                this.refresh();

                break;
            }

            return;
        },

        add: function (items) {

            this.elements.runner.append(items);
            this.refresh();

            return;
        },

        remove: function (selector) {

            if (this.getNoOfItems() > 0) {

                this.elements.items
                    .filter(selector)
                    .remove();

                this.refresh();
            }

            return;
        },

        // returns current index
        getIndex: function () {

            return this.index;

        },

        // returns prev index
        getPrevIndex: function () {

            return this.prevIndex;

        },

        // returns carousel to original state
        destroy: function () {

            var elems = this.elements,
                fullName = this.widgetFullName,
                cssProps = {};

            this.element
                .removeClass(fullName)
                .removeClass(fullName + '-horizontal')
                .removeClass(fullName + '-vertical');
            elems.mask
                .removeClass(fullName + '-mask');
            elems.runner
                .removeClass(fullName + '-runner');
            elems.items
                .removeClass(fullName + '-item');

            if (this.maskAdded) {
                elems.runner
                    .unwrap();
            }

            cssProps[this.isHorizontal ? 'left' : 'top'] = '';
            cssProps[this.isHorizontal ? 'width' : 'height'] = '';
            cssProps.transform = '';
            elems.runner
                .css(cssProps);

            this._removePagination();
            this._removeNextPrevActions();

            elems.runner
                .unbind(this.eventNamespace);

            _super.destroy.apply(this, arguments);

            return;
        }

    });

})(jQuery);

/*global jQuery */
/*jshint bitwise: true, camelcase: true, curly: true, eqeqeq: true, forin: true,
immed: true, indent: 4, latedef: true, newcap: true, nonew: true, quotmark: single,
undef: true, unused: true, strict: true, trailing: true, browser: true */

/*
 * jquery.rs.carousel-autoscroll @VERSION
 * @HOMEPAGE
 *
 * Copyright (c) 2013 Richard Scarrott
 * http://www.richardscarrott.co.uk
 *
 * Dual licensed under the MIT and GPL licenses:
 * http://www.opensource.org/licenses/mit-license.php
 * http://www.gnu.org/licenses/gpl.html
 *
 * Depends:
 *  jquery.js v1.8+
 *  jquery.ui.widget.js v1.8+
 *  jquery.rs.carousel.js v0.11.1
 */
 
(function ($, undefined) {

    'use strict';

    var _super = $.rs.carousel.prototype;
    
    $.widget('rs.carousel', $.rs.carousel, {
    
        options: {
            pause: 4000,
            autoScroll: true
        },
        
        _create: function () {
        
			_super._create.apply(this);
            
            if (!this.options.autoScroll) {
                return;
            }
            
            this._bindAutoScroll();
            this._start();
            
            return;
        },
        
        _bindAutoScroll: function () {
            
            if (this.autoScrollInitiated) {
                return;
            }

            var eventNamespace = this.eventNamespace;
            
            this.element
                .bind('mouseenter' + eventNamespace, $.proxy(this, '_stop'))
                .bind('mouseleave' + eventNamespace, $.proxy(this, '_start'));
                
            this.autoScrollInitiated = true;
            
            return;
        },
        
        _unbindAutoScroll: function () {

            var eventNamespace = this.eventNamespace;
            
            this.element
                .unbind('mouseenter' + eventNamespace)
                .unbind('mouseleave' + eventNamespace);
                
            this.autoScrollInitiated = false;
            
            return;
        },
        
        _start: function () {
        
            var self = this;
            
            this._stop();
            
            this.interval = setInterval(function () {
                if (self.index === self.getNoOfPages()-1) {
                    self.goToPage(0);
                }
                else {
                    self.next();
                }
            }, this.options.pause);
            
            return;
        },
        
        _stop: function () {
        
            clearInterval(this.interval);
            
            return;
        },
        
        _setOption: function (option, value) {
        
            _super._setOption.apply(this, arguments);

            if (option === 'autoScroll' || option === 'pause') {
                
                if (value) {
                    this._bindAutoScroll();
                    this._start();
                }
                else {
                    this._unbindAutoScroll();
                    this._stop();
                }

            }
            
            return;
        },
        
        destroy: function () {
            
            this._stop();
            _super.destroy.apply(this);
            
            return;
        }
        
    });
    
})(jQuery);

/*global jQuery */
/*jshint bitwise: true, camelcase: true, curly: true, eqeqeq: true, forin: true,
immed: true, indent: 4, latedef: true, newcap: true, nonew: true, quotmark: single,
undef: true, unused: true, strict: true, trailing: true, browser: true */

/*
 * jquery.rs.carousel-continuous @VERSION
 * @HOMEPAGE
 *
 * Copyright (c) 2013 Richard Scarrott
 * http://www.richardscarrott.co.uk
 *
 * Dual licensed under the MIT and GPL licenses:
 * http://www.opensource.org/licenses/mit-license.php
 * http://www.gnu.org/licenses/gpl.html
 *
 * Depends:
 *  jquery.js v1.8+
 *  jquery.ui.widget.js v1.8+
 *  jquery.rs.carousel.js v0.11.1
 */
 
(function ($, undefined) {

    'use strict';

    var _super = $.rs.carousel.prototype;
    
    $.widget('rs.carousel', $.rs.carousel, {
    
        options: {
            continuous: false
        },
        
        _create: function () {

            if (this.options.continuous) {
                this.options.loop = true;
                // clones fill whitespace
                this.options.whitespace = true;
            }
        
            _super._create.apply(this, arguments);
            
            return;
        },

        refresh: function () {

            _super.refresh.apply(this, arguments);
            
            if (this.options.continuous) {
                this._addClonedItems();
                this._setRunnerWidth();
                // jump to current page to avoid clones noting the carousel
                // needs to be enabled beforehand
                this.enable();
                this.goToPage(this.index, false, undefined, true);
                this._checkDisabled();
            }
            
            return;
        },
        
        // appends and prepends items to provide illusion of continuous scrolling
        _addClonedItems: function () {

            if (this.options.disabled) {
                this._removeClonedItems();
                return;
            }
        
            var elems = this.elements,
                cloneClass = this.widgetFullName + '-item-clone',
                visibleItems = this._getVisibleItems(0);

            this._removeClonedItems();

            elems.clonedBeginning = visibleItems
                .clone()
                    // add one extra item in case it's partially visible
                    .add(this.elements.items.slice(visibleItems.length).first().clone())
                        .addClass(cloneClass)
                        .appendTo(elems.runner);

            elems.clonedEnd = this.getPage(this.getNoOfPages() - 1)
                .clone()
                    .addClass(cloneClass)
                    .prependTo(elems.runner);
            
            return;
        },

        _removeClonedItems: function () {
        
            var elems = this.elements;
        
            if (elems.clonedBeginning) {
                elems.clonedBeginning.remove();
                elems.clonedBeginning = undefined;
            }
            
            if (elems.clonedEnd) {
                elems.clonedEnd.remove();
                elems.clonedEnd = undefined;
            }
        
        },

        // needs to be overridden to take into account cloned items
        _setRunnerWidth: function () {

            var elems = this.elements,
                width = 0;
            
            if (this.options.continuous) {

                // reset width in case orientation
                // has been changed
                elems.runner.width('');

                if (!this.isHorizontal) {
                    return;
                }
                
                elems.runner
                    .width(function () {
                        elems.items
                            .add(elems.clonedBeginning)
                                .add(elems.clonedEnd)
                                    .each(function () {
                                        width += $(this).outerWidth(true);
                                    });

                        return width;
                    });

            }
            else {
                _super._setRunnerWidth.apply(this, arguments);
            }

            return;
        },

        _slide: function (e) {

            var pos;

            if (this.options.continuous) {

                // if moving to first page
                if (e.type === 'carousel:next' && this.index === 0) {
                    // jump to last page clone
                    pos = this.elements.clonedEnd
                        .first()
                            .position()[this.isHorizontal ? 'left' : 'top'];
                }
                // if moving to last page
                else if (e.type === 'carousel:prev' && this.index === this.getNoOfPages() - 1) {
                    // jump to first page clone
                    pos = this.elements.clonedBeginning
                        .first()
                            .position()[this.isHorizontal ? 'left' : 'top'];
                }

                if (pos !== undefined) {
                    if (this.options.translate3d) {
                        this.elements.runner
                            .css('transform', 'translate3d(' + (this.isHorizontal ? -pos + 'px, 0, 0' : '0, ' + -pos + 'px, 0') + ')');
                    }
                    else {
                        this.elements.runner
                            .css(this.isHorizontal ? 'left' : 'top', -pos);
                    }
                }
            }

            // continue
            _super._slide.apply(this, arguments);

            return;
        },

        // override to avoid clones
        _recacheItems: function () {

            var fullName = this.widgetFullName;

            this.elements.items = this.elements.runner
                .find(this.options.items)
                    .not('.' + fullName + '-item-clone')
                        .addClass(fullName + '-item');

            return;
        },

        add: function (items) {

            if (this.elements.items.length) {

                this.elements.items
                    .last()
                        .after(items);

                this.refresh();

                return;
            }
            
            // cloned items won't exist so use add from prototype (appends to runner)
            _super.add.apply(this, arguments);

            return;
        },

        _setOption: function (option, value) {
            
            _super._setOption.apply(this, arguments);

            if (option === 'continuous') {

                this.options.loop = true;
                this.options.whitespace = true;

                if (!value) {
                    this._removeClonedItems();
                }
                
                this.refresh();
            }
            
            return;
        },
        
        destroy: function () {
            
            this._removeClonedItems();
            
            _super.destroy.apply(this);
            
            return;
        }
        
    });
    
})(jQuery);